\\ Copyright 2015, 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");
recurrence_guess_variable = 'k;

\\-----------------------------------------------------------------------------

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

BlobI_x_8_factor = {(106)/(20825)};

BlobI_x_8floor_factor = {(1)/(2205)};
BlobI_x_8floor_vector = {[318,584,360,2012]};

BlobI_x_4_factor = {-(1)/(53550)};
BlobI_x_4_vector = {[6189,3677,5433,7945]};

BlobI_x_2_factor = {(1)/(15300)};
BlobI_x_2_vector = {[2911,1495,1747,3707]};

BlobI_x_2floor_factor = {-(1)/(630)};
BlobI_x_2floor_vector = {[328,279,965,1533]};

BlobI_x_constant_factor = {(1)/(749700)};
BlobI_x_constant_vector = {[409816,162324,2135281,1887684]};
BlobI_x(k) =
{
  BlobI_x_8_factor * 8^k
  + BlobI_x_8floor_factor
    * vector_modulo(BlobI_x_8floor_vector,k)   * 8^floor(k/2)
  + BlobI_x_4_factor
    * vector_modulo(BlobI_x_4_vector,k)         * 4^k
  + BlobI_x_2_factor
    * vector_modulo(BlobI_x_2_vector,k)         * 2^k
  + BlobI_x_2floor_factor
    * vector_modulo(BlobI_x_2floor_vector,k)   * 2^floor(k/2)
  + BlobI_x_constant_factor
    * vector_modulo(BlobI_x_constant_vector,k);
}
BlobI_x_frac(k) = BlobI_x(k) / BlobSegments(k);


gBlobI_x(x) =
{
  919021/599760/(1 - x)
  + 70727/428400/(1 + x)
  + 29/180/(1 - 2*x)
  - 2/225/(1 + 2*x)
  - 1937/17850/(1 - 4*x)
  + 106/20825/(1 - 8*x)
  + (-16433/14280 - 2054/1785*x)/(1 + x^2)
  + (-431/420 - 151/105*x)/(1 - 2*x^2)
  + (91/180 + 209/210*x)/(1 + 2*x^2)
  + (97/2550 - 553/3825*x)/(1 + 4*x^2)
  + (113/735 + 1298/2205*x)/(1 - 8*x^2)
  + (-1/105 - 34/105*x)/(1 + 8*x^2)
  + (-3/425 + 4268/26775*x)/(1 + 16*x^2)
  ;
}

(106)/(20825)  / (2/5)

\\ recurrence_guess(vector(100,k,k--;  BlobI_x(k) - 53/4165*4^k*BlobSegments(k)));

BlobI_x_reduced(k) =
{
  53/4165*4^k
  +
  (
  vector_modulo([106/735, 584/2205, 8/49, 2012/2205],k) * 2^(3*floor(k/2))
  + vector_modulo([-25/294, -1009/22050, -409/7350, -299/3150],k) * 4^k
  + vector_modulo([2911/15300, 299/3060, 1747/15300, 3707/15300],k) * 2^k
  + vector_modulo([-164/315, -31/70, -193/126, -73/30],k) * 2^floor(k/2)
  + vector_modulo([102454/187425, 4509/20825, 2135281/749700, 157307/62475],k)
   ) / BlobSegments(k);
}
check_exact(vector(100,k,k+=3;  BlobI_x_reduced(k)), \
            vector(100,k,k+=3;  BlobI_x_frac(k)));
vector(10,k,k--;2^(3*floor(k/2)))
vector(10,k,k--;2^(floor(3*k/2)))
vector(10,k,k--;2^(k+floor(k/2)))

BlobI_x_reduced(k) =
{
  53/4165*4^k
  +
  (
  vector_modulo([106/735, 584/2205/2, 8/49, 2012/2205/2],k) * 2^(k+floor(k/2))
  + vector_modulo([-25/294, -1009/22050, -409/7350, -299/3150],k) * 4^k
  + vector_modulo([2911/15300, 299/3060, 1747/15300, 3707/15300],k) * 2^k
  + vector_modulo([-164/315, -31/70, -193/126, -73/30],k) * 2^floor(k/2)
  + vector_modulo([102454/187425, 4509/20825, 2135281/749700, 157307/62475],k)
   ) / BlobSegments(k);
}
check_exact(vector(100,k,k+=3;  BlobI_x_reduced(k)), \
            vector(100,k,k+=3;  BlobI_x_frac(k)));

check_exact([106/735, 584/2205/2, 8/49, 2012/2205/2] / (2/5)  *441, \
            [159, 146, 180, 503]);
\\ {
\\   recurrence_guess(vector(100,k,k--;
\\      BlobI_x(k)
\\      - 53/4165*4^k *BlobSegments(k)
\\      - 1/441*vector_modulo([159, 146, 180, 503],k) * 2^floor(k/2) *BlobSegments(k)
\\      ));
\\ }
BlobI_x_reduced(k) =
{
  53/4165*4^k
  + 1/441 * vector_modulo([159, 146, 180, 503],k) * 2^floor(k/2)
  +
  (
  - 1/22050 * vector_modulo([1875, 1009, 1227, 2093],k) * 4^k
  + vector_modulo([152/441, 15/98, -55/882, 33/14],k) * 2^floor(k/2)
  + vector_modulo([2911/15300, 299/3060, 1747/15300, 3707/15300],k) * 2^k
  + vector_modulo([102454/187425, 4509/20825, 2135281/749700, 157307/62475],k)
   ) / BlobSegments(k);
}
check_exact(vector(100,k,k+=3;  BlobI_x_reduced(k)), \
            vector(100,k,k+=3;  BlobI_x_frac(k)));

check_exact([1875, 1009, 1227, 2093]/22050 / (2/5) * 8820, \
            [1875, 1009, 1227, 2093]);

\\ {
\\   recurrence_guess(vector(100,k,k--;
\\      BlobI_x(k)
\\      - 53/4165*4^k *BlobSegments(k)
\\      - 1/441*vector_modulo([159, 146, 180, 503],k) * 2^floor(k/2) *BlobSegments(k)
\\      + 1/8820 * vector_modulo([1875, 1009, 1227, 2093],k) * 2^k *BlobSegments(k)
\\      ));
\\ }

BlobI_x_reduced(k) =
{
  53/4165*4^k
  - 1/8820 * vector_modulo([1875, 1009, 1227, 2093],k) * 2^k
  + 1/441 * vector_modulo([159, 146, 180, 503],k) * 2^floor(k/2)
  + (
  vector_modulo([152/441, 15/98, -55/882, 33/14],k) * 2^floor(k/2)
  + vector_modulo([-239861/749700, -40561/374850, -289859/749700, -5771/7650],k) * 2^k
  + vector_modulo([102454/187425, 4509/20825, 2135281/749700, 157307/62475],k)
   ) / BlobSegments(k);
}
check_exact(vector(100,k,k+=3;  BlobI_x_reduced(k)), \
            vector(100,k,k+=3;  BlobI_x_frac(k)));

{
  recurrence_guess(vector(100,k,k--;
     BlobI_x(k)
     - 53/4165*4^k *BlobSegments(k)
     + 1/8820 * vector_modulo([1875, 1009, 1227, 2093],k) * 2^k *BlobSegments(k)
     - 1/441*vector_modulo([159, 146, 180, 503],k) * 2^floor(k/2) *BlobSegments(k)
     + 1/299880 * vector_modulo([239861, 81122, 289859, 565558],k) *BlobSegments(k)
     ));
}

BlobI_x_reduced(k) =
{
  53/4165*4^k
  - 1/8820 * vector_modulo([1875, 1009, 1227, 2093],k) * 2^k
  + 1/441 * vector_modulo([159, 146, 180, 503],k) * 2^floor(k/2)
  - 1/299880 * vector_modulo([239861, 81122, 289859, 565558],k)
  + (
      1/882 * vector_modulo([304, 135, -55, 2079],k) * 2^floor(k/2)
    - 1/1764 * vector_modulo([2422, 477, 1114, 9531],k)
    ) / BlobSegments(k);
}
check_exact(vector(100,k,k+=3;  BlobI_x_reduced(k)), \
            vector(100,k,k+=3;  BlobI_x_frac(k)));

{
  p= 53/4165*x^8
    - 1875/8820*x^4
    \\ + 159/441*x^2
    - 239861/299880
}
factor(p*I)
factor(239861) 