\\ Copyright 2015, 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");

\\-----------------------------------------------------------------------------

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

blob_midpoints_at_centroid(k) = {
  my(centroid = BlobGS(k));
  apply(z -> z-centroid, blob_midpoints(k));
}
BlobI_by_points(k) = {
  my(v=blob_midpoints_at_centroid(k));
  my(m=geom_inertia_of_points(v));
  geom_inertia_rotate_xydir(m, b^(k+1));
}

{
  for(k=4,14,
     my(m=BlobI_by_points(k));
     my(v=[geom_inertia_Ix(m),geom_inertia_Iy(m),geom_inertia_Ixy(m)]);
     v=apply(denominator,v);
     my(l=lcm(v), s=BlobSegments(k));
     print("k="k" segs "s"  lcm "l"  ratio "l/s);
     );
}
