\\ Copyright 2014, 2015, 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

GBQN(k) = GLQN(k) + GRQN(k);
GBQN_ref = GBQN;
gGBQN(x) = gGLQN(x) + gGRQN(x);
check_exact(gf_terms(gGBQN(x), 100), vector(100,k,my(k=k-1); GBQN(k)))

gGBQN_ref = gGBQN;
check_exact(gGBQN(x), gGBQN_ref(x));

read("pol-ascend.gp");
read("pol-pfrac.gp");

gGBQN(x) =
{
  (-1/2 + 1/2*I)
  + (57/82 - 21/82*I)/(1 - x)
  + 1/41 * ((33 - 10*I)
            + (31 + 8*I)*x
            + (31 + 49*I)*x^2)
  /(1 - b*x - 2*b^3*x^3)
  ;
}
print("gGBQN_ref(x)");
pol_ascending_print(pol_partial_fractions(gGBQN_ref(x)));
check_exact(gGBQN(x), gGBQN_ref(x), "gGBQN");

print("tt");
tt = [ gBQ(b*x); (gBQ(b*x)-2)*1/(b*x); (gBQ(b*x)-2-3*b*x)*1/(b*x)^2 ];
pol_ascending_print(pol_partial_fractions(tt[1,1]))
pol_ascending_print(pol_partial_fractions(tt[2,1]))
pol_ascending_print(pol_partial_fractions(tt[3,1]))

{
  fv = matsolve(mattranspose([2,  1 + I,   4*I;
                 3,  2 + 2*I, 8*I;
                 5,  4 + 4*I, 12*I]),
                [(33/41 - 10/41*I);
                 (31/41 + 8/41*I);
                 (31/41 + 49/41*I)])
}
(22/41 + 7/41*I)*2 + (-63/164 - 7/164*I)*3 + (29/164 - 15/164*I)*5

print("product");
pp = vecsum(Vec(fv*mattranspose(tt)));
pol_ascending_print(pol_partial_fractions(pp[1]))

print("gGBQN(x)");
pol_ascending_print(pol_partial_fractions(gGBQN(x)))

print("terms");
{
pol_ascending_print(pol_partial_fractions(
  + (22/41 + 7/41*I) * gBQ(b*x)
  + (-63/164 - 7/164*I) * (gBQ(b*x)-2)*1/(b*x)
  + (29/164 - 15/164*I) * (gBQ(b*x)-2-3*b*x)*1/(b*x)^2
))
}
\\ {
\\ pol_ascending_print(pol_partial_fractions(
\\   + (35/41 - 28/41*I) * gBQ(b*x)
\\   + ( 9/41 + 42/41*I) * (gBQ(b*x)-2)*1/(b*x)
\\   + (-5/164 + 1/41*I) * (gBQ(b*x)-2-4*b*x)*1/(b*x)^2
\\ ))
\\ }

gGBQN(x) =
{
  (-1/2 + 1/2*I)
  + (57/82 - 21/82*I)/(1 - x)

  + (22/41 + 7/41*I) * gBQ(b*x)
  + (-63/164 - 7/164*I) * (gBQ(b*x)-2)*1/(b*x)
  + (29/164 - 15/164*I) * (gBQ(b*x)-2-3*b*x)*1/(b*x)^2
  ;
}
print("difference");
pol_ascending_print(pol_partial_fractions(gGBQN(x)-gGBQN_ref(x)))
check_exact(gGBQN(x), gGBQN_ref(x));

GBQN(k) =
{
  if(k==0,return(1));
  (57/82 - 21/82*I)
  + ((22/41 + 7/41*I) * BQ(k)
     - (63/164 + 7/164*I) * BQ(k+1)
     + (29/164 - 15/164*I) * BQ(k+2)
    ) * b^k
  ;
}
vector(7,k,k--; GBQN(k))
check_exact(gf_terms(gBQ(b*x), 100), \
            vector(100,k,my(k=k-1); b^k*BQ(k)), \
            "gBQ(b*k)")
check_exact(gf_terms((gBQ(b*x)-2)*1/(b*x), 100), \
            vector(100,k,my(k=k-1); b^k*BQ(k+1)), \
            "gBQ(b*k)/(b*x)")
check_exact(gf_terms((gBQ(b*x)-2-4*b*x)*1/(b*x)^2, 100), \
            vector(100,k,my(k=k-1); b^k*BQ(k+2)), \
            "gBQ(b*k)/(b*x)^2")

check_exact(vector(100,k,my(k=k-1); GBQN(k)), \
            vector(100,k,my(k=k-1); GBQN_ref(k)), \
            "GBQN");

GBQF =
{
  + (22/41 + 7/41*I  ) 
  - (63/164 + 7/164*I) * r
  + (29/164 - 15/164*I) * r^2
}

GRf_delta = GRf - 1/2
GBQF_delta = GBQF - 1/2
GRf_delta / GBQF_delta
GBQF_delta / GRf_delta

quit
