\\ Copyright 2019 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


allocatemem(200*10^6);
default(recover,0);
default(strictargs,1);
read("dragon-defines.gp");
\\ read("../tools/recurrence-guess.gp");

want = polrecip(cubic(x))

{
  for(n=3229,350000,
     my(anum=Strprintf("A%06d",n),
        v=OEIS_samples(anum),
        gf=recurrence_guess_values_to_gf(v));
     if(gf==0,next);
     my(den=denominator(gf));
     if(den % want == 0,
        print(anum" "gf);
        print("  contains cubic in denominator "den);

        my(roots=polroots(polrecip(den)));
        roots=abs(roots);
        roots=vecsort(roots);
        my(max_root=roots[#roots]);
        print("  max root "max_root);
        if(max_root > r+.1,
           print("    but other bigger factors"));
       );
  );
}