\\ Copyright 2016, 2017, 2019 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0);
read("../tools/geom.gp");
read("../tools/geom-inertia.gp");

check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

sqrt3i = quadgen(-12);
check_exact(sqrt3i^2, -3);
w6 = 1/2 + 1/2*sqrt3i;
w3 = w6^2;
check_exact(w6^3, -1);
check_exact(w6^6, 1);
check_exact(w3^3, 1);
check_exact(imag(w3),1/2);
sqrt3 = geom_sqrt_as_quad(3);
sqrt7 = geom_sqrt_as_quad(7);
sqrt21 = geom_sqrt_as_quad(21);
check_exact(sqrt21^2, 21);
vector_differences(v) = if(#v==0,[], vector(#v-1,i,v[i+1]-v[i]));
b = 2+w6;
check_exact(norm(b),7)

\\-----------------------------------------------------------------------------
digitpoints = [ 0, 1, w6, w3, -1, -w6, -w3 ];
fromdigits_arbitrary(v,base=10) = subst(Pol(v),'x,base);

flowsnake_points(k) =
{
  my(v=[0]);
  for(i=1,k,
     v=concat(apply(z->z*=b;apply(d->z+d,digitpoints), v)));
  v;
}
check_exact(flowsnake_points(0), [0]);
check_exact(flowsnake_points(1), digitpoints);
geom_centroid_of_points(flowsnake_points(2))

geom_inertia_of_points(flowsnake_points(4))
