\\ Copyright 2014, 2015, 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

{
print("HGf ",
      geom_centroid_of_polygon(conj([Benedek_Panzone_P10,
                                     Benedek_Panzone_P9,
                                     Benedek_Panzone_P8,
                                     Benedek_Panzone_P7,
                                     Benedek_Panzone_P6,
                                     Benedek_Panzone_P5,
                                     Benedek_Panzone_P4,
                                     Benedek_Panzone_P3,
                                     Benedek_Panzone_P2,
                                     Benedek_Panzone_P1])));
}


\\-----------------------------------------------------------------------------

HG_samples = [ 1/2+0*I, 2/3+1/3*I, 4/9+7/9*I, -4/9+29/27*I, -37/23+40/69*I, -191/84+-41/42*I, -496/363+-1163/363*I, 749/387+-190/43*I, 10445/1617+-3956/1617*I, 15086/1677+2211/559*I, 34844/6819+29289/2273*I, -54491/6921+123502/6921*I ]
HG_samp(k) = HG_samples[k+1];

b_vector = [ 1, 1+I, I, -1+I, -1, -1-I, -I, 1-I ];
b_factor(k) = b_vector[(k%8)+1];
b_power(k) = b_factor(k)*2^floor(k/2);
vector(100,k,my(k=k-1); b^k) == vector(100,k,my(k=k-1); b_power(k)) || quit;

constant_vector = [1, 2, 3, 2];
constant(k) = k%=4; constant_vector[k+1];
half_factor_vector = [11, 14+1/2, 11, 15+1/2];
half_factor(k) = k%=4; half_factor_vector[k+1];
hull_area(k) = 1/6 * (7*2^k - half_factor(k)*2^floor(k/2) + constant(k));

check(name="") = my(bad=0); \
          for(k=6,length(HG_samples)-1, \
              my(want=HG_samp(k)); \
              my(got=HG(k)); \
              if(got != want, \
                 bad+=1;print("k=",k," want ",want," got ",got); \
                 if(bad>10,break))); \
          if(bad!=0,error("bad, ",name)); \
          print("ok");

HG=HG_samp
check();

\\----------------------------------------------------------------------

hull_area(8)
geom_area_of_polygon(hull(8))
my(k=8);if(hull_area(k) != geom_area_of_polygon(hull(k)), print("oops");quit(1))

HG(k) = {geom_centroid_of_polygon([P1(k),P2(k),P3(k),P4(k),P5(k),
                           P6(k),P7(k),P8(k),P9(k),P10(k)])}
check("geom_centroid_of_polygon");

HG(k) =
{
  -( geom_centroid_of_triangle(P1(k),P2(k))  * geom_area_of_triangle(P1(k),P2(k))
    + geom_centroid_of_triangle(P2(k),P3(k))  * geom_area_of_triangle(P2(k),P3(k))
    + geom_centroid_of_triangle(P3(k),P4(k))  * geom_area_of_triangle(P3(k),P4(k))
    + geom_centroid_of_triangle(P4(k),P5(k))  * geom_area_of_triangle(P4(k),P5(k))
    + geom_centroid_of_triangle(P5(k),P6(k))  * geom_area_of_triangle(P5(k),P6(k))
    + geom_centroid_of_triangle(P6(k),P7(k))  * geom_area_of_triangle(P6(k),P7(k))
    + geom_centroid_of_triangle(P7(k),P8(k))  * geom_area_of_triangle(P7(k),P8(k))
    + geom_centroid_of_triangle(P8(k),P9(k))  * geom_area_of_triangle(P8(k),P9(k))
    + geom_centroid_of_triangle(P9(k),P10(k)) * geom_area_of_triangle(P9(k),P10(k))
    + geom_centroid_of_triangle(P10(k),P1(k)) * geom_area_of_triangle(P10(k),P1(k))
   ) / hull_area(k);
}
check("geom_centroid_of_triangle");

HG(k) =
{ -1/9/2 *(
    geom_centroid_of_triangle(P1(k),P2(k)) * imag(       (1-I)*2^(k+2) +         conj(b^(k+3))*p(k+2) +         conj(p(k+3))*b^(k+2) + conj(p(k+3))*p(k+2))
  + geom_centroid_of_triangle(P2(k),P3(k)) * imag(      (1-I)*2^(k+1) +         conj(b^(k+2))*p(k+1) +         conj(p(k+2))*b^(k+1) + conj(p(k+2))*p(k+1) )
  + geom_centroid_of_triangle(P3(k),P4(k)) * imag(      (1-I)*2^k     +         conj(b^(k+1))*p(k+0) +         conj(p(k+1))*b^(k+0) + conj(p(k+1))*p(k+0) )
  + geom_centroid_of_triangle(P4(k),P5(k)) * imag(      (1-I)*2^(k-1) +         conj(b^(k+0))*p(k-1) +         conj(p(k+0))*b^(k-1) + conj(p(k+0))*p(k-1) )
  + geom_centroid_of_triangle(P5(k),P6(k)) * imag(   (-1-3*I)*2^(k-1) +      -I*conj(b^(k-1))*p(k+1) +  -(2+I)*conj(p(k-1))*b^k     + -I*conj(p(k-1))*p(k+1) )
  + geom_centroid_of_triangle(P6(k),P7(k)) * imag(( 7 - I)   *2^k     + (1+2*I)*conj(b^k) * p(k)     +  (3+I) *conj(I*p(k+1)) * b^k +    conj(p(k+1))*p(k) )
  + geom_centroid_of_triangle(P7(k),P8(k)) * imag((22 - 4*I) *2^(k-1) + (1+3*I)*conj(b^k) * p(k-1)   + (3+4*I)*conj(I*p(k))*b^(k-1) +    conj(p(k))*p(k-1) )
  + geom_centroid_of_triangle(P8(k),P9(k)) * imag((49 - 7*I) *2^(k-2) + (4+3*I)*conj(b^(k-1))*p(k-2) +   7    *conj(p(k-1))* b^(k-2) + conj(p(k-1))* p(k-2) )
  + geom_centroid_of_triangle(P9(k),P10(k)) * imag((35 - 21*I)*2^(k-2) + -7*I   *conj(b^(k-2))*p(k)   + (1-4*I)*conj(p(k-2))*b^(k-1) + -I*conj(p(k-2))*p(k) )
  + geom_centroid_of_triangle(P10(k),P1(k)) * imag((16 - 4*I) *2^(k-1) + (-4+I) *conj(b^(k-1))*p(k+3) +        -conj(p(k))*b^(k+3)   + -conj(p(k))* p(k+3) )
  ) / hull_area(k);
}
check("geom_centroid_of_triangle, area formulas");

HG(k) =
{ -1/9/2 *(
    (P1(k) + P2(k))/3 * imag(       (1-I)*2^(k+2) +         conj(b^(k+3))*p(k+2) +         conj(p(k+3))*b^(k+2) + conj(p(k+3))*p(k+2))
  + (P2(k)+P3(k))/3 * imag(      (1-I)*2^(k+1) +         conj(b^(k+2))*p(k+1) +         conj(p(k+2))*b^(k+1) + conj(p(k+2))*p(k+1) )
  + (P3(k)+P4(k))/3 * imag(      (1-I)*2^k     +         conj(b^(k+1))*p(k+0) +         conj(p(k+1))*b^(k+0) + conj(p(k+1))*p(k+0) )
  + (P4(k)+P5(k))/3 * imag(      (1-I)*2^(k-1) +         conj(b^(k+0))*p(k-1) +         conj(p(k+0))*b^(k-1) + conj(p(k+0))*p(k-1) )
  + (P5(k)+P6(k))/3 * imag(   (-1-3*I)*2^(k-1) +      -I*conj(b^(k-1))*p(k+1) +  -(2+I)*conj(p(k-1))*b^k     + -I*conj(p(k-1))*p(k+1) )
  + (P6(k)+P7(k))/3 * imag(( 7 - I)   *2^k     + (1+2*I)*conj(b^k) * p(k)     +  (3+I) *conj(I*p(k+1)) * b^k +    conj(p(k+1))*p(k) )
  + (P7(k)+P8(k))/3 * imag((22 - 4*I) *2^(k-1) + (1+3*I)*conj(b^k) * p(k-1)   + (3+4*I)*conj(I*p(k))*b^(k-1) +    conj(p(k))*p(k-1) )
  + (P8(k)+P9(k))/3 * imag((49 - 7*I) *2^(k-2) + (4+3*I)*conj(b^(k-1))*p(k-2) +   7    *conj(p(k-1))* b^(k-2) + conj(p(k-1))* p(k-2) )
  + (P9(k)+P10(k))/3 * imag((35 - 21*I)*2^(k-2) + -7*I   *conj(b^(k-2))*p(k)   + (1-4*I)*conj(p(k-2))*b^(k-1) + -I*conj(p(k-2))*p(k) )
  + (P10(k)+P1(k))/3 * imag((16 - 4*I) *2^(k-1) + (-4+I) *conj(b^(k-1))*p(k+3) +        -conj(p(k))*b^(k+3)   + -conj(p(k))* p(k+3) )
  ) / hull_area(k);
}
check();

HG(k) =
{ -1/27/2  / hull_area(k) *(
    (P1(k) + P2(k)) * imag(       (1-I)*2^(k+2) +         conj(b^(k+3))*p(k+2) +         conj(p(k+3))*b^(k+2) + conj(p(k+3))*p(k+2))
  + (P2(k) + P3(k)) * imag(      (1-I)*2^(k+1) +         conj(b^(k+2))*p(k+1) +         conj(p(k+2))*b^(k+1) + conj(p(k+2))*p(k+1) )
  + (P3(k) + P4(k)) * imag(      (1-I)*2^k     +         conj(b^(k+1))*p(k+0) +         conj(p(k+1))*b^(k+0) + conj(p(k+1))*p(k+0) )
  + (P4(k) + P5(k)) * imag(      (1-I)*2^(k-1) +         conj(b^(k+0))*p(k-1) +         conj(p(k+0))*b^(k-1) + conj(p(k+0))*p(k-1) )
  + (P5(k) + P6(k)) * imag(   (-1-3*I)*2^(k-1) +      -I*conj(b^(k-1))*p(k+1) +  -(2+I)*conj(p(k-1))*b^k     + -I*conj(p(k-1))*p(k+1) )
  + (P6(k) + P7(k)) * imag(( 7 - I)   *2^k     + (1+2*I)*conj(b^k) * p(k)     +  (3+I) *conj(I*p(k+1)) * b^k +    conj(p(k+1))*p(k) )
  + (P7(k) + P8(k)) * imag((22 - 4*I) *2^(k-1) + (1+3*I)*conj(b^k) * p(k-1)   + (3+4*I)*conj(I*p(k))*b^(k-1) +    conj(p(k))*p(k-1) )
  + (P8(k) + P9(k)) * imag((49 - 7*I) *2^(k-2) + (4+3*I)*conj(b^(k-1))*p(k-2) +   7    *conj(p(k-1))* b^(k-2) + conj(p(k-1))* p(k-2) )
  + (P9(k) + P10(k)) * imag((35 - 21*I)*2^(k-2) + -7*I   *conj(b^(k-2))*p(k)   + (1-4*I)*conj(p(k-2))*b^(k-1) + -I*conj(p(k-2))*p(k) )
  + (P10(k)+ P1(k)) * imag((16 - 4*I) *2^(k-1) + (-4+I) *conj(b^(k-1))*p(k+3) +        -conj(p(k))*b^(k+3)   + -conj(p(k))* p(k+3) )
  );
}
check();

HG(k) =
{ -1/27/2  / hull_area(k) *(
    (- (b^(k+3) + p(k+3))/3 + - (b^(k+2) + p(k+2))/3) * imag(       (1-I)*2^(k+2) +         conj(b^(k+3))*p(k+2) +         conj(p(k+3))*b^(k+2) + conj(p(k+3))*p(k+2))
  + (- (b^(k+2) + p(k+2))/3 + - (b^(k+1) + p(k+1))/3) * imag(      (1-I)*2^(k+1) +         conj(b^(k+2))*p(k+1) +         conj(p(k+2))*b^(k+1) + conj(p(k+2))*p(k+1) )
  + (- (b^(k+1) + p(k+1))/3 + - (b^(k+0) + p(k+0))/3) * imag(      (1-I)*2^k     +         conj(b^(k+1))*p(k+0) +         conj(p(k+1))*b^(k+0) + conj(p(k+1))*p(k+0) )
  + (- (b^(k+0) + p(k+0))/3 + - (b^(k-1) + p(k-1))/3) * imag(      (1-I)*2^(k-1) +         conj(b^(k+0))*p(k-1) +         conj(p(k+0))*b^(k-1) + conj(p(k+0))*p(k-1) )
  + (- (b^(k-1) + p(k-1))/3 + ((2+I)*b^k + I*p(k+1)) / 3) * imag(   (-1-3*I)*2^(k-1) +      -I*conj(b^(k-1))*p(k+1) +  -(2+I)*conj(p(k-1))*b^k     + -I*conj(p(k-1))*p(k+1) )
  + (((2+I)*b^k + I*p(k+1)) / 3 + ((3+I)*b^k + I*p(k))/3) * imag(( 7 - I)   *2^k     + (1+2*I)*conj(b^k) * p(k)     +  (3+I) *conj(I*p(k+1)) * b^k +    conj(p(k+1))*p(k) )
  + (((3+I)*b^k + I*p(k))/3 + (b^k - I*- (b^(k-1) + p(k-1))/3)) * imag((22 - 4*I) *2^(k-1) + (1+3*I)*conj(b^k) * p(k-1)   + (3+4*I)*conj(I*p(k))*b^(k-1) +    conj(p(k))*p(k-1) )
  + (b^k - I*- (b^(k-1) + p(k-1))/3 + (7*I*b^(k-2) + I*p(k-2))/3) * imag((49 - 7*I) *2^(k-2) + (4+3*I)*conj(b^(k-1))*p(k-2) +   7    *conj(p(k-1))* b^(k-2) + conj(p(k-1))* p(k-2) )
  + ((7*I*b^(k-2) + I*p(k-2))/3 + ((4+I)* b^(k-1) + p(k)) / 3) * imag((35 - 21*I)*2^(k-2) + -7*I   *conj(b^(k-2))*p(k)   + (1-4*I)*conj(p(k-2))*b^(k-1) + -I*conj(p(k-2))*p(k) )
  + (((4+I)* b^(k-1) + p(k)) / 3+ - (b^(k+3) + p(k+3))/3) * imag((16 - 4*I) *2^(k-1) + (-4+I) *conj(b^(k-1))*p(k+3) +        -conj(p(k))*b^(k+3)   + -conj(p(k))* p(k+3) )
  );
}
check();

HG(k) =
{ -1/81/2  / hull_area(k) *(
    (- (b^(k+3) + p(k+3)) + - (b^(k+2) + p(k+2))) * imag(       (1-I)*2^(k+2) +         conj(b^(k+3))*p(k+2) +         conj(p(k+3))*b^(k+2) + conj(p(k+3))*p(k+2))
  + (- (b^(k+2) + p(k+2)) + - (b^(k+1) + p(k+1))) * imag(      (1-I)*2^(k+1) +         conj(b^(k+2))*p(k+1) +         conj(p(k+2))*b^(k+1) + conj(p(k+2))*p(k+1) )
  + (- (b^(k+1) + p(k+1)) + - (b^(k+0) + p(k+0))) * imag(      (1-I)*2^k     +         conj(b^(k+1))*p(k+0) +         conj(p(k+1))*b^(k+0) + conj(p(k+1))*p(k+0) )
  + (- (b^(k+0) + p(k+0)) + - (b^(k-1) + p(k-1))) * imag(      (1-I)*2^(k-1) +         conj(b^(k+0))*p(k-1) +         conj(p(k+0))*b^(k-1) + conj(p(k+0))*p(k-1) )
  + (- (b^(k-1) + p(k-1)) + ((2+I)*b^k + I*p(k+1))) * imag(   (-1-3*I)*2^(k-1) +      -I*conj(b^(k-1))*p(k+1) +  -(2+I)*conj(p(k-1))*b^k     + -I*conj(p(k-1))*p(k+1) )
  + (((2+I)*b^k + I*p(k+1)) + ((3+I)*b^k + I*p(k))) * imag(( 7 - I)   *2^k     + (1+2*I)*conj(b^k) * p(k)     +  (3+I) *conj(I*p(k+1)) * b^k +    conj(p(k+1))*p(k) )
  + (((3+I)*b^k + I*p(k)) + (3*b^k - I*-(b^(k-1) + p(k-1)))) * imag((22 - 4*I) *2^(k-1) + (1+3*I)*conj(b^k) * p(k-1)   + (3+4*I)*conj(I*p(k))*b^(k-1) +    conj(p(k))*p(k-1) )
  + (3*b^k - I*-(b^(k-1) + p(k-1)) + (7*I*b^(k-2) + I*p(k-2))) * imag((49 - 7*I) *2^(k-2) + (4+3*I)*conj(b^(k-1))*p(k-2) +   7    *conj(p(k-1))* b^(k-2) + conj(p(k-1))* p(k-2) )
  + ((7*I*b^(k-2) + I*p(k-2)) + ((4+I)* b^(k-1) + p(k))) * imag((35 - 21*I)*2^(k-2) + -7*I   *conj(b^(k-2))*p(k)   + (1-4*I)*conj(p(k-2))*b^(k-1) + -I*conj(p(k-2))*p(k) )
  + (((4+I)* b^(k-1) + p(k)) + -(b^(k+3) + p(k+3))) * imag((16 - 4*I) *2^(k-1) + (-4+I) *conj(b^(k-1))*p(k+3) +        -conj(p(k))*b^(k+3)   + -conj(p(k))* p(k+3) )
  );
}
check();

HG(k) =
{ -1/81/2  / hull_area(k) *(
    (- b^(k+3) - p(k+3) - b^(k+2) - p(k+2)) * imag(       (1-I)*2^(k+2) +         conj(b^(k+3))*p(k+2) +         conj(p(k+3))*b^(k+2) + conj(p(k+3))*p(k+2))
  + (- b^(k+2) - p(k+2) - b^(k+1) - p(k+1)) * imag(      (1-I)*2^(k+1) +         conj(b^(k+2))*p(k+1) +         conj(p(k+2))*b^(k+1) + conj(p(k+2))*p(k+1) )
  + (- b^(k+1) - p(k+1) - b^(k+0) - p(k+0)) * imag(      (1-I)*2^k     +         conj(b^(k+1))*p(k+0) +         conj(p(k+1))*b^(k+0) + conj(p(k+1))*p(k+0) )
  + (- b^(k+0) - p(k+0) - b^(k-1) - p(k-1)) * imag(      (1-I)*2^(k-1) +         conj(b^(k+0))*p(k-1) +         conj(p(k+0))*b^(k-1) + conj(p(k+0))*p(k-1) )
  + (- b^(k-1) - p(k-1) + (2+I)*b^k + I*p(k+1)) * imag(   (-1-3*I)*2^(k-1) +      -I*conj(b^(k-1))*p(k+1) +  -(2+I)*conj(p(k-1))*b^k     + -I*conj(p(k-1))*p(k+1) )
  + ((2+I)*b^k + I*p(k+1) + (3+I)*b^k + I*p(k)) * imag(( 7 - I)   *2^k     + (1+2*I)*conj(b^k) * p(k)     +  (3+I) *conj(I*p(k+1)) * b^k +    conj(p(k+1))*p(k) )
  + (((3+I)*b^k + I*p(k)) + (3*b^k - I*-(b^(k-1) + p(k-1)))) * imag((22 - 4*I) *2^(k-1) + (1+3*I)*conj(b^k) * p(k-1)   + (3+4*I)*conj(I*p(k))*b^(k-1) +    conj(p(k))*p(k-1) )
  + (3*b^k + I*b^(k-1) + I*p(k-1) + 7*I*b^(k-2) + I*p(k-2)) * imag((49 - 7*I) *2^(k-2) + (4+3*I)*conj(b^(k-1))*p(k-2) +   7    *conj(p(k-1))* b^(k-2) + conj(p(k-1))* p(k-2) )
  + (7*I*b^(k-2) + I*p(k-2) + (4+I)* b^(k-1) + p(k)) * imag((35 - 21*I)*2^(k-2) + -7*I   *conj(b^(k-2))*p(k)   + (1-4*I)*conj(p(k-2))*b^(k-1) + -I*conj(p(k-2))*p(k) )
  + ((4+I)* b^(k-1) + p(k)  - b^(k+3) - p(k+3)) * imag((16 - 4*I) *2^(k-1) + (-4+I) *conj(b^(k-1))*p(k+3) +        -conj(p(k))*b^(k+3)   + -conj(p(k))* p(k+3) )
  );
}
check();

HG(k) =
{ -1/81/2  / hull_area(k) *(
    (( 2 - 4*I)    *b^k - p(k+3) - p(k+2)  )   * imag(      (4-4*I )*2^k +         conj(b^(k+3))*p(k+2) +         conj(p(k+3))*b^(k+2) +    conj(p(k+3))*p(k+2))
  + ((-1 - 3*I)    *b^k - p(k+2) - p(k+1)  )   * imag(      (2-2*I )*2^k +         conj(b^(k+2))*p(k+1) +         conj(p(k+2))*b^(k+1) +    conj(p(k+2))*p(k+1) )
  + ((-2 -   I)    *b^k - p(k+1) - p(k+0)  )   * imag(        (1-I )*2^k +         conj(b^(k+1))*p(k+0) +         conj(p(k+1))*b^(k+0) +    conj(p(k+1))*p(k+0) )
  + ((-3/2 + 1/2*I)*b^k - p(k+0) - p(k-1)  )   * imag(  (1/2-1/2*I )*2^k +         conj(b^(k+0))*p(k-1) +         conj(p(k+0))*b^(k-1) +    conj(p(k+0))*p(k-1) )
  + (( 3/2 + 3/2*I)*b^k + p(k+3) + I*p(k+1))   * imag( (-1/2-3/2*I )*2^k +      -I*conj(b^(k-1))*p(k+1) +  -(2+I)*conj(p(k-1))*b^k     + -I*conj(p(k-1))*p(k+1) )
  + ((5    +   2*I)*b^k + I*p(k+1) + I*p(k))   * imag( ( 7 - I     )*2^k + (1+2*I)*conj(b^k) * p(k)     +  (3+I) *conj(I*p(k+1)) * b^k +    conj(p(k+1))*p(k) )
  + ((13/2 + 3/2*I)*b^k + I*p(k) + I*p(k-1))   * imag( (11 - 2*I   )*2^k + (1+3*I)*conj(b^k) * p(k-1)   + (3+4*I)*conj(I*p(k))*b^(k-1) +    conj(p(k))*p(k-1) )
  + ((7 + 1/2*I   )*b^k - I*p(k+3) - I*p(k+2)) * imag( (49/4-7/4*I )*2^k + (4+3*I)*conj(b^(k-1))*p(k-2) +   7    *conj(p(k-1))* b^(k-2) +   conj(p(k-1))* p(k-2) )
  + ((6 - 3/2*I   )*b^k - I*p(k+2) + p(k)  )   * imag( (35/4-21/4*I)*2^k + -7*I   *conj(b^(k-2))*p(k)   + (1-4*I)*conj(p(k-2))*b^(k-1) + -I*conj(p(k-2))*p(k) )
  + ((9/2 - 7/2*I )*b^k + p(k) - p(k+3)    )   * imag( (8- 2*I     )*2^k + (-4+I) *conj(b^(k-1))*p(k+3) +        -conj(p(k))*b^(k+3)   +   -conj(p(k))* p(k+3) )
  );
}
check();

vector(8,k,my(k=k-1); imag(    -conj(p(k))* p(k+3) ))
HG(k) =
{ -1/81/2  / hull_area(k) *(
    (( 2 - 4*I)    *b^k - p(k+3) - p(k+2)  )   * ( -4  *2^k + [2, -2, -1, -2, 2, -2, -1, -2][(k%8)+1] + imag(         conj(b^(k+3))*p(k+2) +         conj(p(k+3))*b^(k+2) ))
  + ((-1 - 3*I)    *b^k - p(k+2) - p(k+1)  )   * ( -2  *2^k + [-2, 2, -2, -1, -2, 2, -2, -1][(k%8)+1] + imag(         conj(b^(k+2))*p(k+1) +         conj(p(k+2))*b^(k+1) ))
  + ((-2 -   I)    *b^k - p(k+1) - p(k+0)  )   * ( -1  *2^k + [-1, -2, 2, -2, -1, -2, 2, -2][(k%8)+1] + imag(         conj(b^(k+1))*p(k+0) +         conj(p(k+1))*b^(k+0) ))
  + ((-3/2 + 1/2*I)*b^k - p(k+0) - p(k-1)  )   * (-1/2 *2^k + [-2, -1, -2, 2, -2, -1, -2, 2][(k%8)+1] + imag(         conj(b^(k+0))*p(k-1) +         conj(p(k+0))*b^(k-1) ))
  + (( 3/2 + 3/2*I)*b^k + p(k+3) + I*p(k+1))   * (-3/2 *2^k + [3, 0, -3, 0, 3, 0, -3, 0][(k%8)+1]     + imag(      -I*conj(b^(k-1))*p(k+1) +  -(2+I)*conj(p(k-1))*b^k   ))
  + ((5    +   2*I)*b^k + I*p(k+1) + I*p(k))   * ( -1  *2^k + [-1, -2, 2, -2, -1, -2, 2, -2][(k%8)+1] + imag( (1+2*I)*conj(b^k) * p(k)     +  (3+I) *conj(I*p(k+1)) * b^k ))
  + ((13/2 + 3/2*I)*b^k + I*p(k) + I*p(k-1))   * ( -2  *2^k + [-2, -1, -2, 2, -2, -1, -2, 2][(k%8)+1] + imag( (1+3*I)*conj(b^k) * p(k-1)   + (3+4*I)*conj(I*p(k))*b^(k-1) ))
  + ((7 + 1/2*I   )*b^k - I*p(k+3) - I*p(k+2)) * (-7/4 *2^k + [2, -2, -1, -2, 2, -2, -1, -2][(k%8)+1] + imag( (4+3*I)*conj(b^(k-1))*p(k-2) +   7    *conj(p(k-1))* b^(k-2) ))
  + ((6 - 3/2*I   )*b^k - I*p(k+2) + p(k)  )   * (-21/4*2^k + [0, 3, 0, -3, 0, 3, 0, -3][(k%8)+1]     +  imag( -7*I  *conj(b^(k-2))*p(k)   + (1-4*I)*conj(p(k-2))*b^(k-1)  ))
  + ((9/2 - 7/2*I )*b^k + p(k) - p(k+3)    )   * (-2   *2^k + [-2, -1, -2, 2, -2, -1, -2, 2][(k%8)+1] + imag( (-4+I) *conj(b^(k-1))*p(k+3) +        -conj(p(k))*b^(k+3)   ))
  );
}
check();

HG(k) =
{ my(pow = 2^k,
     half = 2^floor(k/2));
 -1/162  / hull_area(k) *(
    (( 2 - 4*I)    *b^k - p(k+3) - p(k+2)  )   * ( -4  *pow + [2, -2, -1, -2, 2, -2, -1, -2][(k%8)+1] + half*imag(         conj(b_factor(k+3))*2*2^(k%2)*p(k+2) +       2*conj(p(k+3))*b_factor(k+2) ))
  + ((-1 - 3*I)    *b^k - p(k+2) - p(k+1)  )   * ( -2  *pow + [-2, 2, -2, -1, -2, 2, -2, -1][(k%8)+1] + half*imag(         conj(b_factor(k+2))*2*p(k+1) +         conj(p(k+2))*b_factor(k+1)*2^(k%2) ))
  + ((-2 -   I)    *b^k - p(k+1) - p(k+0)  )   * ( -1  *pow + [-1, -2, 2, -2, -1, -2, 2, -2][(k%8)+1] + half*imag(         conj(b_factor(k+1))*2^(k%2)*p(k+0) +         conj(p(k+1))*b_factor(k) ))
  + ((-3/2 + 1/2*I)*b^k - p(k+0) - p(k-1)  )   * (-1/2 *pow + [-2, -1, -2, 2, -2, -1, -2, 2][(k%8)+1] + half*imag(         conj(b_factor(k))*p(k-1) +         conj(p(k+0))*b_factor(k-1)*1/2*2^(k%2) ))
  + (( 3/2 + 3/2*I)*b^k + p(k+3) + I*p(k+1))   * (-3/2 *pow + [3, 0, -3, 0, 3, 0, -3, 0][(k%8)+1]     + half*imag(      -I*conj(b_factor(k-1))*1/2*2^(k%2)*p(k+1) +  -(2+I)*conj(p(k-1))*b_factor(k)   ))
  + ((5    +   2*I)*b^k + I*p(k+1) + I*p(k))   * ( -1  *pow + [-1, -2, 2, -2, -1, -2, 2, -2][(k%8)+1] + half*imag( (1+2*I)*conj(b_factor(k)) * p(k)     +  (3+I) *conj(I*p(k+1))*b_factor(k) ))
  + ((13/2 + 3/2*I)*b^k + I*p(k) + I*p(k-1))   * ( -2  *pow + [-2, -1, -2, 2, -2, -1, -2, 2][(k%8)+1] + half*imag( (1+3*I)*conj(b_factor(k)) * p(k-1)   + (3+4*I)*conj(I*p(k))*b_factor(k-1)*1/2*2^(k%2) ))
  + ((7 + 1/2*I   )*b^k - I*p(k+3) - I*p(k+2)) * (-7/4 *pow + [2, -2, -1, -2, 2, -2, -1, -2][(k%8)+1] + half*imag( (4+3*I)*conj(b_factor(k-1))*1/2*2^(k%2)*p(k-2) +   7    *conj(p(k-1))*b_factor(k-2)*1/2 ))
  + ((6 - 3/2*I   )*b^k - I*p(k+2) + p(k)  )   * (-21/4*pow + [0, 3, 0, -3, 0, 3, 0, -3][(k%8)+1]     +  half*imag( -7*I  *conj(b_factor(k-2))*1/2*p(k)   + (1-4*I)*conj(p(k-2))*b_factor(k-1)*1/2*2^(k%2)  ))
  + ((9/2 - 7/2*I )*b^k + p(k) - p(k+3)    )   * (-2   *pow + [-2, -1, -2, 2, -2, -1, -2, 2][(k%8)+1] + half*imag( (-4+I) *conj(b_factor(k-1))*1/2*2^(k%2)*p(k+3) +        -conj(p(k))*b_factor(k+3)*2*2^(k%2)   ))
  );
}
check();

vector(8,k,my(k=k-1);  imag( (-4+I) *conj(b_factor(k-1))*1/2*2^(k%2)*p(k+3) +        -conj(p(k))*b_factor(k+3)*2*2^(k%2)   )       )
HG(k) =
{ my(pow = 2^k,
     half = 2^floor(k/2));
 -1/162  / hull_area(k) *(
    (( 2 - 4*I)    *b^k - p(k+3) - p(k+2)  )   * ( -4  *pow + [2, -2, -1, -2, 2, -2, -1, -2][(k%8)+1] + half*[2, 10, 4, 8, 2, 10, 4, 8][(k%8)+1])
  + ((-1 - 3*I)    *b^k - p(k+2) - p(k+1)  )   * ( -2  *pow + [-2, 2, -2, -1, -2, 2, -2, -1][(k%8)+1] + half*[4, 2, 5, 4, 4, 2, 5, 4][(k%8)+1]  )
  + ((-2 -   I)    *b^k - p(k+1) - p(k+0)  )   * ( -1  *pow + [-1, -2, 2, -2, -1, -2, 2, -2][(k%8)+1] + half*[2, 4, 1, 5, 2, 4, 1, 5][(k%8)+1]  )
  + ((-3/2 + 1/2*I)*b^k - p(k+0) - p(k-1)  )   * (-1/2 *pow + [-2, -1, -2, 2, -2, -1, -2, 2][(k%8)+1] + half*[5/2, 2, 2, 1, 5/2, 2, 2, 1][(k%8)+1] )
  + (( 3/2 + 3/2*I)*b^k + p(k+3) + I*p(k+1))   * (-3/2 *pow + [3, 0, -3, 0, 3, 0, -3, 0][(k%8)+1]     + half*[3, 3, 9/2, 6, 3, 3, 9/2, 6][(k%8)+1] )
  + ((5    +   2*I)*b^k + I*p(k+1) + I*p(k))   * ( -1  *pow + [-1, -2, 2, -2, -1, -2, 2, -2][(k%8)+1] + half*[2, 4, 1, 5, 2, 4, 1, 5][(k%8)+1] )
  + ((13/2 + 3/2*I)*b^k + I*p(k) + I*p(k-1))   * ( -2  *pow + [-2, -1, -2, 2, -2, -1, -2, 2][(k%8)+1] + half*[17/2, 5, 5, -2, 17/2, 5, 5, -2][(k%8)+1] )
  + ((7 + 1/2*I   )*b^k - I*p(k+3) - I*p(k+2)) * (-7/4 *pow + [2, -2, -1, -2, 2, -2, -1, -2][(k%8)+1] + half*[-5/2, 29/2, 4, 8, -5/2, 29/2, 4, 8][(k%8)+1] )
  + ((6 - 3/2*I   )*b^k - I*p(k+2) + p(k)  )   * (-21/4*pow + [0, 3, 0, -3, 0, 3, 0, -3][(k%8)+1]     +  half*[3, -6, 3/2, 27/2, 3, -6, 3/2, 27/2][(k%8)+1] )
  + ((9/2 - 7/2*I )*b^k + p(k) - p(k+3)    )   * (-2   *pow + [-2, -1, -2, 2, -2, -1, -2, 2][(k%8)+1] + half*[17/2, 5, 5, -2, 17/2, 5, 5, -2][(k%8)+1] )
  );
}
check();

HG(k) =
{ my(pow = 2^k,
     half = 2^floor(k/2));
 -1/162  / hull_area(k) *(
  (
    (( 2 - 4*I)    )   * ( -4 )
  + ((-1 - 3*I)        )   * ( -2  )
  + ((-2 -   I)        )   * ( -1  )
  + ((-3/2 + 1/2*I)     )   * (-1/2  )
  + (( 3/2 + 3/2*I)   )   * (-3/2  )
  + ((5    +   2*I)   )   * ( -1   )
  + ((13/2 + 3/2*I)   )   * ( -2   )
  + ((7 + 1/2*I   ) ) * (-7/4  )
  + ((6 - 3/2*I   )     )   * (-21/4 )
  + ((9/2 - 7/2*I )       )   * (-2   )
  ) * pow * b^k
  + (
    (( 2 - 4*I)    )   * ( [2, 10, 4, 8, 2, 10, 4, 8][(k%8)+1] )
  + ((-1 - 3*I)         )   * ([4, 2, 5, 4, 4, 2, 5, 4][(k%8)+1]  )
  + ((-2 -   I)         )   * ( [2, 4, 1, 5, 2, 4, 1, 5][(k%8)+1]  )
  + ((-3/2 + 1/2*I)     )   * ( [5/2, 2, 2, 1, 5/2, 2, 2, 1][(k%8)+1] )
  + (( 3/2 + 3/2*I)   )   * ( [3, 3, 9/2, 6, 3, 3, 9/2, 6][(k%8)+1] )
  + ((5    +   2*I)   )   * ( [2, 4, 1, 5, 2, 4, 1, 5][(k%8)+1] )
  + ((13/2 + 3/2*I)   )   * ( [17/2, 5, 5, -2, 17/2, 5, 5, -2][(k%8)+1] )
  + ((7 + 1/2*I   ) ) * ( [-5/2, 29/2, 4, 8, -5/2, 29/2, 4, 8][(k%8)+1] )
  + ((6 - 3/2*I   )     )   * ( [3, -6, 3/2, 27/2, 3, -6, 3/2, 27/2][(k%8)+1] )
  + ((9/2 - 7/2*I )       )   * ( [17/2, 5, 5, -2, 17/2, 5, 5, -2][(k%8)+1] )
  ) * half * b^k
  + (
    ( 2 - 4*I    )   * ( [2, -2, -1, -2, 2, -2, -1, -2][(k%8)+1] )
  + ((-1 - 3*I)         )   * (  [-2, 2, -2, -1, -2, 2, -2, -1][(k%8)+1]   )
  + ((-2 -   I)         )   * (  [-1, -2, 2, -2, -1, -2, 2, -2][(k%8)+1]   )
  + ((-3/2 + 1/2*I)     )   * ( [-2, -1, -2, 2, -2, -1, -2, 2][(k%8)+1]  )
  + (( 3/2 + 3/2*I)   )   * ( [3, 0, -3, 0, 3, 0, -3, 0][(k%8)+1]      )
  + ((5    +   2*I)   )   * (  [-1, -2, 2, -2, -1, -2, 2, -2][(k%8)+1]  )
  + ((13/2 + 3/2*I)   )   * (  [-2, -1, -2, 2, -2, -1, -2, 2][(k%8)+1]  )
  + ((7 + 1/2*I   ) ) * ( [2, -2, -1, -2, 2, -2, -1, -2][(k%8)+1] )
  + ((6 - 3/2*I   )     )   * ( [0, 3, 0, -3, 0, 3, 0, -3][(k%8)+1]      )
  + ((9/2 - 7/2*I )       )   * ( [-2, -1, -2, 2, -2, -1, -2, 2][(k%8)+1] )
  ) * b^k
  + (
    ( - p(k+3) - p(k+2)  )  * ( -4 )
  + (- p(k+2) - p(k+1)    ) * ( -2    )
  + (- p(k+1) - p(k+0)    ) * ( -1    )
  + (- p(k+0) - p(k-1)    ) * (-1/2  )
  + (+ p(k+3) + I*p(k+1)  ) * (-3/2  )
  + (+ I*p(k+1) + I*p(k)  ) * ( -1   )
  + (+ I*p(k) + I*p(k-1)  ) * ( -2   )
  + (- I*p(k+3) - I*p(k+2)) * (-7/4  )
  + (- I*p(k+2) + p(k)    ) * (-21/4 )
  + (+ p(k) - p(k+3)      ) * (-2    )
  ) * pow
  + (
    ( - p(k+3) - p(k+2)  )   * ( [2, 10, 4, 8, 2, 10, 4, 8][(k%8)+1] )
  + ( - p(k+2) - p(k+1)    ) * ( [4, 2, 5, 4, 4, 2, 5, 4][(k%8)+1]  )
  + ( - p(k+1) - p(k+0)    ) * ( [2, 4, 1, 5, 2, 4, 1, 5][(k%8)+1]  )
  + ( - p(k+0) - p(k-1)    ) * ( [5/2, 2, 2, 1, 5/2, 2, 2, 1][(k%8)+1] )
  + ( + p(k+3) + I*p(k+1)  ) * ( [3, 3, 9/2, 6, 3, 3, 9/2, 6][(k%8)+1] )
  + ( + I*p(k+1) + I*p(k)  ) * ( [2, 4, 1, 5, 2, 4, 1, 5][(k%8)+1] )
  + ( + I*p(k) + I*p(k-1)  ) * ( [17/2, 5, 5, -2, 17/2, 5, 5, -2][(k%8)+1] )
  + ( - I*p(k+3) - I*p(k+2)) * ( [-5/2, 29/2, 4, 8, -5/2, 29/2, 4, 8][(k%8)+1] )
  + ( - I*p(k+2) + p(k)    ) * ( [3, -6, 3/2, 27/2, 3, -6, 3/2, 27/2][(k%8)+1] )
  + ( + p(k) - p(k+3)      ) * ( [17/2, 5, 5, -2, 17/2, 5, 5, -2][(k%8)+1] )
  ) * half
  + (
    ( - p(k+3) - p(k+2)  ) * ( [2, -2, -1, -2, 2, -2, -1, -2][(k%8)+1] )
  + ( - p(k+2) - p(k+1)    ) * ( [-2, 2, -2, -1, -2, 2, -2, -1][(k%8)+1]   )
  + ( - p(k+1) - p(k+0)    ) * ( [-1, -2, 2, -2, -1, -2, 2, -2][(k%8)+1]   )
  + ( - p(k+0) - p(k-1)    ) * ( [-2, -1, -2, 2, -2, -1, -2, 2][(k%8)+1]  )
  + ( + p(k+3) + I*p(k+1)  ) * ( [3, 0, -3, 0, 3, 0, -3, 0][(k%8)+1]      )
  + ( + I*p(k+1) + I*p(k)  ) * ( [-1, -2, 2, -2, -1, -2, 2, -2][(k%8)+1]  )
  + ( + I*p(k) + I*p(k-1)  ) * ( [-2, -1, -2, 2, -2, -1, -2, 2][(k%8)+1]  )
  + ( - I*p(k+3) - I*p(k+2)) * ( [2, -2, -1, -2, 2, -2, -1, -2][(k%8)+1]  )
  + ( - I*p(k+2) + p(k)    ) * ( [0, 3, 0, -3, 0, 3, 0, -3][(k%8)+1]      )
  + ( + p(k) - p(k+3)      ) * ( [-2, -1, -2, 2, -2, -1, -2, 2][(k%8)+1]  )
  )
  );
}
check();

HG(k) =
{ my(pow = 2^k,
     half = 2^floor(k/2));
 -1/162  / hull_area(k) *(
    (-305/4 + 59/2*I ) * pow * b^k
  + [403/4 - 35*I, 152 - 121/4*I, 407/4 - 65/2*I, 299/2 - 167/4*I,
     403/4 - 35*I, 152 - 121/4*I, 407/4 - 65/2*I, 299/2 - 167/4*I][(k%8)+1]
      * half * b^k
  + [5/2 + 11/2*I, -35/2 - 4*I, -49/2 + 10*I, -22 + 19/2*I,
     5/2 + 11/2*I, -35/2 - 4*I, -49/2 + 10*I, -22 + 19/2*I][(k%8)+1]
      * b^k
  + [ 71/4 - 85/4*I,  39/4 - 25/2*I, -31/4 + 91/4*I, -23/4 + 33*I,
     -71/4 + 85/4*I, -39/4 + 25/2*I,  31/4 - 91/4*I,  23/4 - 33*I][(k%8)+1]
      * pow
  + [-4 + 37/2*I,  15 + 23*I,  53/2 - 35/2*I,  13 - 69/2*I,
      4 - 37/2*I, -15 - 23*I, -53/2 + 35/2*I, -13 + 69/2*I][(k%8)+1]
      * half
  + [-7 - 4*I, -12 + 2*I, -4 + 7*I,  2 + 12*I,
      7 + 4*I,  12 - 2*I,  4 - 7*I, -2 - 12*I][(k%8)+1]
  );
}
check();

HG(k) =
{ my(pow = 2^k,
     half = 2^floor(k/2));
 -1/189  *(
    (-305/4 + 59/2*I ) * pow * b^k
  + [403/4 - 35*I, 152 - 121/4*I, 407/4 - 65/2*I, 299/2 - 167/4*I,
     403/4 - 35*I, 152 - 121/4*I, 407/4 - 65/2*I, 299/2 - 167/4*I][(k%8)+1]
      * half * b^k
  + [5/2 + 11/2*I, -35/2 - 4*I, -49/2 + 10*I, -22 + 19/2*I,
     5/2 + 11/2*I, -35/2 - 4*I, -49/2 + 10*I, -22 + 19/2*I][(k%8)+1]
      * b^k
  + [ 71/4 - 85/4*I,  39/4 - 25/2*I, -31/4 + 91/4*I, -23/4 + 33*I,
     -71/4 + 85/4*I, -39/4 + 25/2*I,  31/4 - 91/4*I,  23/4 - 33*I][(k%8)+1]
      * pow
  + [-4 + 37/2*I,  15 + 23*I,  53/2 - 35/2*I,  13 - 69/2*I,
      4 - 37/2*I, -15 - 23*I, -53/2 + 35/2*I, -13 + 69/2*I][(k%8)+1]
      * half
  + [-7 - 4*I, -12 + 2*I, -4 + 7*I,  2 + 12*I,
      7 + 4*I,  12 - 2*I,  4 - 7*I, -2 - 12*I][(k%8)+1]
  )
  / ( pow
      - half* [11/7, 29/14, 11/7, 31/14, 11/7, 29/14, 11/7, 31/14][(k%8)+1]
      + [1/7, 2/7, 3/7, 2/7, 1/7, 2/7, 3/7, 2/7][(k%8)+1] );
}
check();

HG(k) =
{ my(pow = 2^k,
     half = 2^floor(k/2));
  (305/756 - 59/378*I) * b^k
 - 1/189*(
  (
  + [-267/14 + 159/14*I, -333/56 + 216/7*I, -253/14 + 97/7*I, -1083/56 + 165/7*I, -267/14 + 159/14*I, -333/56 + 216/7*I, -253/14 + 97/7*I, -1083/56 + 165/7*I][(k%8)+1]
      * half * b^k
  + [375/28 + 9/7*I, 30/7 - 87/7*I, 229/28 - 37/14*I, -3/14 + 15/14*I, 375/28 + 9/7*I, 30/7 - 87/7*I, 229/28 - 37/14*I, -3/14 + 15/14*I][(k%8)+1]
      * b^k
  + [ 71/4 - 85/4*I,  39/4 - 25/2*I, -31/4 + 91/4*I, -23/4 + 33*I,
     -71/4 + 85/4*I, -39/4 + 25/2*I,  31/4 - 91/4*I,  23/4 - 33*I][(k%8)+1]
      * pow
  + [-4 + 37/2*I,  15 + 23*I,  53/2 - 35/2*I,  13 - 69/2*I,
      4 - 37/2*I, -15 - 23*I, -53/2 + 35/2*I, -13 + 69/2*I][(k%8)+1]
      * half
  + [-7 - 4*I, -12 + 2*I, -4 + 7*I,  2 + 12*I,
      7 + 4*I,  12 - 2*I,  4 - 7*I, -2 - 12*I][(k%8)+1]
  )
  / ( pow
      - half* [11/7, 29/14, 11/7, 31/14, 11/7, 29/14, 11/7, 31/14][(k%8)+1]
      + [1/7, 2/7, 3/7, 2/7, 1/7, 2/7, 3/7, 2/7][(k%8)+1] )
  );
}
check();



HG(k) =
{ my(pow = 2^k,
     half = 2^floor(k/2));
  (305/756 - 59/378*I) * b^k
  + [ 89/882 - 53/882*I,  229/2352 - 155/2352*I,  97/1323 + 253/2646*I,  79/7056 + 89/784*I,
     -89/882 + 53/882*I, -229/2352 + 155/2352*I, -97/1323 - 253/2646*I, -79/7056 - 89/784*I][(k%8)+1]

 - 1/189*(
  (
  + [ 71/4 - 85/4*I,  39/4 - 25/2*I, -31/4 + 91/4*I, -23/4 + 33*I,
     -71/4 + 85/4*I, -39/4 + 25/2*I,  31/4 - 91/4*I,  23/4 - 33*I][(k%8)+1]
      * pow

  + [-4033/196 + 1844/49*I, -10041/1568 + 63751/1568*I,  361/49 - 7393/196*I,  11693/1568 - 130605/1568*I,
      4033/196 - 1844/49*I,  10041/1568 - 63751/1568*I, -361/49 + 7393/196*I, -11693/1568 + 130605/1568*I][(k%8)+1]
    *  half

  + [-419/98 - 551/98*I, -2643/392 - 611/392*I,  95/49 + 1445/98*I,  1021/392 + 7107/392*I,
      419/98 + 551/98*I,  2643/392 + 611/392*I, -95/49 - 1445/98*I, -1021/392 - 7107/392*I][(k%8)+1]
  )
  / ( pow
      - half* [11/7, 29/14, 11/7, 31/14, 11/7, 29/14, 11/7, 31/14][(k%8)+1]
      + [1/7, 2/7, 3/7, 2/7, 1/7, 2/7, 3/7, 2/7][(k%8)+1] )
  );
}
check();

{
print(vector(8,k,my(k=k-1);
[717/98 + 831/196*I, 21627/1568 + 23151/1568*I, -943/196 - 193/98*I, -8271/1568 - 16029/1568*I,
     -717/98 - 831/196*I, -21627/1568 - 23151/1568*I, 943/196 + 193/98*I, 8271/1568 + 16029/1568*I][(k%8)+1]
/ b_factor(k)

))}

HG(k) =
{
  my(pow = 2^k,
     half = 2^floor(k/2));

  (305/756 - 59/378*I) * b^k

  + 1/21168 * vector_modulo([148 + 1108*I, 969 + 5*I, 2420 - 524*I, 881 - 1293*I,
                            -148 - 1108*I, -969 - 5*I, -2420 + 524*I, -881 + 1293*I],k)

  - 1/189
  * (
     + vector_modulo([717/98 + 831/196*I, 21627/1568 + 23151/1568*I, -943/196 - 193/98*I, -8271/1568 - 16029/1568*I,
                      -717/98 - 831/196*I, -21627/1568 - 23151/1568*I, 943/196 + 193/98*I, 8271/1568 + 16029/1568*I],k)
     *  half

     + vector_modulo([-1335/196 - 507/196*I, -3735/392 + 789/392*I,  1031/196 + 979/196*I,  1665/392 + 3411/392*I,
                      1335/196 + 507/196*I,  3735/392 - 789/392*I, -1031/196 - 979/196*I, -1665/392 - 3411/392*I],k)
    )
  / ( pow
     - half* vector_modulo([11/7, 29/14, 11/7, 31/14, 11/7, 29/14, 11/7, 31/14],k)
     + vector_modulo([1/7, 2/7, 3/7, 2/7, 1/7, 2/7, 3/7, 2/7],k)
    )
  ;
}
check();

\\-----------------------------------------------------------------------------
\\ HGN

HGN(k) =
{ my(pow = 2^k,
     half = 2^floor(k/2));
 -1/162  *(
    (-305/4 + 59/2*I ) * pow * b^k
  + [403/4 - 35*I, 152 - 121/4*I, 407/4 - 65/2*I, 299/2 - 167/4*I,
     403/4 - 35*I, 152 - 121/4*I, 407/4 - 65/2*I, 299/2 - 167/4*I][(k%8)+1]
      * half * b^k
  + [5/2 + 11/2*I, -35/2 - 4*I, -49/2 + 10*I, -22 + 19/2*I,
     5/2 + 11/2*I, -35/2 - 4*I, -49/2 + 10*I, -22 + 19/2*I][(k%8)+1]
      * b^k
  + [ 71/4 - 85/4*I,  39/4 - 25/2*I, -31/4 + 91/4*I, -23/4 + 33*I,
     -71/4 + 85/4*I, -39/4 + 25/2*I,  31/4 - 91/4*I,  23/4 - 33*I][(k%8)+1]
      * pow
  + [-4 + 37/2*I,  15 + 23*I,  53/2 - 35/2*I,  13 - 69/2*I,
      4 - 37/2*I, -15 - 23*I, -53/2 + 35/2*I, -13 + 69/2*I][(k%8)+1]
      * half
  + [-7 - 4*I, -12 + 2*I, -4 + 7*I,  2 + 12*I,
      7 + 4*I,  12 - 2*I,  4 - 7*I, -2 - 12*I][(k%8)+1]
  );
}
check_exact(vector(100,k,my(k=k+5); HGN(k)), \
            vector(100,k,my(k=k+5); HGN_by_triangles(k)), \
           "HGN 1")

HGN(k) =
{ my(pow = 2^k,
     half = 2^floor(k/2));
 1/648  *(
    (305 - 118*I) * pow * b^k         /* (2b)^k == (sqrt(2)*2)^k */

    + vector_modulo([-403 + 140*I, -608 + 121*I, -407 + 130*I, -598 + 167*I,
                     -403 + 140*I, -608 + 121*I, -407 + 130*I, -598 + 167*I],k)
      * half * b^k                    /* (sqrt(2)*b)^k == 2^k */

  + vector_modulo([-10 - 22*I, 70 + 16*I, 98 - 40*I, 88 - 38*I,
                   -10 - 22*I, 70 + 16*I, 98 - 40*I, 88 - 38*I],k)
      * b^k                          /* b^k  == sqrt(2)^k */

  + vector_modulo([-71 + 85*I, -39 + 50*I, 31 - 91*I, 23 - 132*I,
                   71 - 85*I, 39 - 50*I, -31 + 91*I, -23 + 132*I],k)
          * pow                      /* 2^k */
  + 2*vector_modulo([8 - 37*I, -30 - 46*I, -53 + 35*I, -26 + 69*I,
                   -8 + 37*I, 30 + 46*I, 53 - 35*I, 26 - 69*I],k)
          * half                     /* sqrt(2)^k == b^k  */

  + 4*vector_modulo([7 + 4*I, 12 - 2*I, 4 - 7*I, -2 - 12*I,
                     -7 - 4*I, -12 + 2*I, -4 + 7*I, 2 + 12*I],k)
  );
}
check_exact(vector(100,k,my(k=k+5); HGN(k)), \
            vector(100,k,my(k=k+5); HGN_by_triangles(k)), \
            "HGN 2")

\\ plothraw(real([7 + 4*I, 12 - 2*I, 4 - 7*I, -2 - 12*I,   -7 - 4*I, -12 + 2*I, -4 + 7*I, 2 + 12*I]), \
\\          imag([7 + 4*I, 12 - 2*I, 4 - 7*I, -2 - 12*I,   -7 - 4*I, -12 + 2*I, -4 + 7*I, 2 + 12*I]), \
\\         1);

\\ {
\\ for(k=0,31, print((
\\                    vector_modulo([-10 - 22*I, 70 + 16*I, 98 - 40*I, 88 - 38*I,
\\                                   -10 - 22*I, 70 + 16*I, 98 - 40*I, 88 - 38*I],k)
\\                    * b^k                          /* b^k  == sqrt(2)^k */
\\                    +
\\                    2*vector_modulo([8 - 37*I, -30 - 46*I, -53 + 35*I, -26 + 69*I,
\\                                     -8 + 37*I, 30 + 46*I, 53 - 35*I, 26 - 69*I],k)
\\                    * 2^floor(k/2)
\\                   ) / b^k,
\\                   ","))
\\ }

\\ {
\\ for(k=0,31, print((
\\ 4*vector_modulo([7 + 4*I, 12 - 2*I, 4 - 7*I, -2 - 12*I,
\\                      -7 - 4*I, -12 + 2*I, -4 + 7*I, 2 + 12*I],k)
\\                   ) / oct(k),
\\                   ","))
\\ }

\\ {
\\ for(k=0,31, print((
\\     + vector_modulo([-403 + 140*I, -608 + 121*I, -407 + 130*I, -598 + 167*I,
\\                      -403 + 140*I, -608 + 121*I, -407 + 130*I, -598 + 167*I],k)
\\       * 2^floor(k/2) * b^k                    /* (sqrt(2)*b)^k == 2^k */
\\
\\   + vector_modulo([-71 + 85*I, -39 + 50*I, 31 - 91*I, 23 - 132*I,
\\                    71 - 85*I, 39 - 50*I, -31 + 91*I, -23 + 132*I],k)
\\           * 2^k                      /* 2^k */
\\                   ) / (
\\                        2^floor(k/2) * b^k
\\                       ),
\\                   ","))
\\ }

HGN(k) =
{ 1/648  *(
           (305 - 118*I) * 2^k

           + vector_modulo([-474 + 225*I,
                            -597 + 210*I,
                            -498 + 99*I,
                            -753 + 276*I ],k) * 2^floor(k/2)

           + 3*vector_modulo([2 - 32*I,
                              -2,
                              56 + 22*I,
                              61 - 27*I],k)
          )
  * b^k

  + 1/162*vector_modulo([7 + 4*I, 12 - 2*I, 4 - 7*I, -2 - 12*I,
                         -7 - 4*I, -12 + 2*I, -4 + 7*I, 2 + 12*I],k)
  ;
}
check_exact(vector(100,k,my(k=k+5); HGN(k)), \
            vector(100,k,my(k=k+5); HGN_by_triangles(k)), \
            "HGN 3")

HGN(k) =
{ b^k
  * ( (305/648 - 59/324*I) * 2^k

       + vector_modulo([-79/108 + 25/72*I,
                       -199/216 + 35/108*I,
                         -83/108 + 11/72*I,
                         -251/216 + 23/54*I],k) * 2^floor(k/2)

       + vector_modulo([ 1/108 - 4/27*I,
                        -1/108,
                        7/27 + 11/108*I,
                        61/216 - 1/8*I],k)
       )
 
  + 1/162*vector_modulo([7 + 4*I, 12 - 2*I, 4 - 7*I, -2 - 12*I,
                         -7 - 4*I, -12 + 2*I, -4 + 7*I, 2 + 12*I],k)
  ;
}
check_exact(vector(100,k,my(k=k+5); HGN(k)), \
            vector(100,k,my(k=k+5); HGN_by_triangles(k)), \
            "HGN final")

HGN_multiply_high = 305/648 - 59/324*I;
HGN_multiply_half = [-79/108 + 25/72*I, -199/216 + 35/108*I, -83/108 + 11/72*I, -251/216 + 23/54*I];
HGN_multiply_low = [1/108 - 4/27*I, -1/108, 7/27 + 11/108*I, 61/216 - 1/8*I];
HGN_constant_vector = [7 + 4*I, 12 - 2*I, 4 - 7*I, -2 - 12*I, -7 - 4*I, -12 + 2*I, -4 + 7*I, 2 + 12*I];
HGN(k) = {
  b^k*(HGN_multiply_high * 2^k
       + vector_modulo(HGN_multiply_half,k)*2^floor(k/2)
       + vector_modulo(HGN_multiply_low,k)
      )
  + 1/162*vector_modulo(HGN_constant_vector,k);
}
check_exact(vector(100,k,my(k=k+5); HGN(k)), \
            vector(100,k,my(k=k+5); HGN_by_triangles(k)), \
            "HGN final 2")

print("HGN ",vector(10,k,k+=5;  HGN(k)))
