\\ Copyright 2016 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");

\\-----------------------------------------------------------------------------

\\ (1/d) = 1 always
\\ vector(16,d,kronecker(1,d))
jacobi_denominator(v) =
{
  if(#v==0,return(0));
  if(v[1]!=1, return(0));
  for(den=0,10e6,
     for(n=1,#v,
        if(kronecker(n,den)!=v[n],
           next(2)));
     return(den));
  0;
}

{
  for(vv=0,31,
     my(v=binary(vv));
     v=apply(b->-1+2*b,v);
     \\ v=concat([1],v);
     my(den=jacobi_denominator(v));
     my(got_v=vector(#v,n,kronecker(n,den)));
     print(v,"  ",den," ",binary(den)," gives ",got_v));
}