\\ Copyright 2016, 2017, 2018 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");
default(seriesprecision,7);


check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

PlotterJump(k) = recurse_move_to_end(k);
PlotterDist(k) = {
  if(k==0,0,
    2*PlotterDist(k-1) + abs(PlotterJump(k)));
}
PlotterDist = memoize(PlotterDist);

PlotterJump_by_powers(k) = {
  (4/5 + 2/5*I) * (1 + I)^k
  + vector_modulo([1/5 - 2/5*I, -2/5 - 1/5*I, -1/5 + 2/5*I, 2/5 + 1/5*I ],k);
}
check_exact(vector(100,k, PlotterJump_by_powers(k)), \
            vector(100,k, PlotterJump(k)));

gPlotterJump(x) = \
  (1/5 - 2/5*I)/(1 + I*x) + (4/5 + 2/5*I)/(1 - (1 + I)*x);
check_exact(gf_terms(gPlotterJump(x),100)[^1], \
            vector(99,k, PlotterJump(k)));

PlotterJumpNorm(k) = {
  4/5 * (2^k
         + vector_modulo([0,-1,1,-1, 0,1,-1,1],k)*2^floor(k/2)
         + 1/4);
}
check_exact(vector(100,k, PlotterJumpNorm(k)), \
            vector(100,k, norm(PlotterJump(k))));

PlotterJumpNorm(k) = {
  4/5 * (2^k
         + vector_modulo([0, -1/2*sqrt2,  1, -1/2*sqrt2,
                          0,  1/2*sqrt2, -1,  1/2*sqrt2],k) * sqrt2^k
         + 1/4);
}
check_exact(vector(100,k, PlotterJumpNorm(k)), \
            vector(100,k, norm(PlotterJump(k))));

recurse_move_abs_root_part(k) = {
  1
  + vector_modulo([0, -1/2*sqrt2,  1, -1/2*sqrt2,
                   0,  1/2*sqrt2, -1,  1/2*sqrt2],k) / sqrt2^k
  + 1/4 * 1/2^k;
}
PlotterJumpNorm(k) = \
  2^k * 4/5 * recurse_move_abs_root_part(k);
check_exact(vector(100,k, PlotterJumpNorm(k)), \
            vector(100,k, norm(PlotterJump(k))));

PlotterJump_mean(k) = {
  2^k/(2^k-1) * 2/sqrt(5)
  * sum(j=1,k, 1/sqrt2^j * sqrt(recurse_move_abs_root_part(j)));
}                 

PlotterJump_mean(100)*1.0

my(k=100); PlotterDist(k)/(2^k-1)
my(k=500); PlotterDist(k)/(2^k-1)
\\ 2.1091175011


quit

\\  vector(16,k, PlotterJumpNorm(k))
\\  vector(16,k, norm(PlotterJump(k)))
\\  vector(20,k, PlotterJump(k))
\\  vector(20,k,k+=3; issquare(norm(PlotterJump(k))))
\\  vector(40,k,k+=3; core(norm(PlotterJump(k))))
\\  vector(16,k, sqrtint(norm(PlotterJump(4*k+2))/core(norm(PlotterJump(4*k+2)))))
\\ 


f(x) = 1/(2^x+1);
f(x)

print("f'");
f(x)'
\\ d/dx 1/(2^x+1)
1/(2^x+1)^2 * -1 * log(2) * 2^x
f1(x) = 1/( (2^(1/2))^x + (2^(-1/2))^x)^2 * -1 * log(2);
f1(x)
f1(0)
1/( 1 + 1 )^2 * -1 * log(2)
1/4 * -1 * log(2)
quit

