\\ Copyright 2014 Kevin Ryde
\\
\\ dragon.gp is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ dragon.gp is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with dragon.gp  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


\\ Usage: gp <dragon.gp
\\
\\ Draw a dragon curve using PARI/GP.

len=256;

bit_above_low_1(n) = bittest(n, valuation(n,2)+1);

plotinit(0);
plotscale(0, -32,32, 32,-32); \\ Y increasing up the screen
plotmove(0, 0,0);
plotstring(0, "start", 8+32); \\ flags 8=top + 32=gap

dx=1;
dy=0;
turn_right()= [dx,dy]=[-dy,dx];
turn_left() = [dx,dy]=[dy,-dx];

for(i=1,len, plotrline(0,dx,dy); \
             if(bit_above_low_1(i), turn_right(), turn_left()));
plotdraw([0,100,100]);

