#!/usr/bin/perl -w

# Copyright 2015, 2017, 2019 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.

use 5.004;
use strict;

use FindBin;
use lib $FindBin::Bin;
use MyPrintwrap ':all';


my $width = 9;
my $height = 5;

print "  % generated by tools/$FindBin::Script\n";

{
  $Printwrap = 2;
  printwrap("\\path foreach \\p in {");
  $Printwrap += 2;
  foreach my $y (0 .. $height-1) {
    foreach my $x (0 .. $width-1) {
      if (($x + $y) % 2 == 0) {
        # even
        printwrap("($x,$y),");
      }
    }
  }
  printwrap("}");
  printwrap(" { \\p pic[transform shape] {my hexagon pic} };\n");

  $Printwrap = 2;
  printwrap("\\path foreach \\p in {");
  $Printwrap += 2;
  foreach my $y (0 .. $height-1) {
    foreach my $x (0 .. $width-1) {
      if (($x + $y) % 2 != 0) {
        # odd
        if ($x > 0 || $x < $width-1) {
          printwrap("($x,$y),");
        }
      }
    }
  }
  printwrap("}");
  printwrap(" { \\p pic[transform shape] {my across pic} };\n");
}

{
  print "  \\begin{scope}[my square colour]\n";
  $Printwrap = 4;
  foreach my $y (0 .. $height) {
    foreach my $x (0 .. $width) {
      printwrap(" \\node (p$x$y) at ($x,$y) [my dot];");
    }
  }
  printwrap_newline();
  foreach my $y (0 .. $height) {
    foreach my $x (0 .. $width) {
      {
        my $x1 = $x;
        my $x2 = $x+1;
        if ($x2 <= $width) {
          if (($x+$y) % 2) { ($x1,$x2) = ($x2,$x1); }
          printwrap(" \\draw[->](p$x1$y)--(p$x2$y);");
        }
      }
      {
        my $y1 = $y;
        my $y2 = $y+1;
        if ($y2 <= $height) {
          if (($x+$y) % 2) { ($y1,$y2) = ($y2,$y1); }
          printwrap(" \\draw[->](p$x$y1)--(p$x$y2);");
        }
      }
    }
  }
  printwrap_newline();
  print "  \\end{scope}\n";
}

print "  % end generated\n";
exit 0;
