#!/usr/bin/perl -w

# Copyright 2016, 2017 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.

use 5.004;
use strict;
use Math::PlanePath::DragonCurve 117; # v.117 for level_to_n_range()

use FindBin;
use lib $FindBin::Bin;
use MyPrintwrap ':all';
use Math::BigRat;


my $max_depth = 3;
print "  % generated by tools/$FindBin::Script\n";

sub XYindent_points {
  my ($x,$y, $len, $depth) = @_;
  if ($depth == 0) {
    return ([$x,$y]);
  } else {
    return (XYindent_points($x,$y, $len/4,  $depth-1),
            [$x+$len/4, $y-$len/4],
            [$x+$len/4, $y-$len*3/4],
            XYindent_points($x+$len*3/4, $y-$len*3/4, $len/4,  $depth-1));
  }
}
my @points = (XYindent_points(Math::BigRat->new('0'),
                              Math::BigRat->new('1'),
                              Math::BigRat->new('1'),
                              $max_depth),
              [1,0]);

$Printwrap = 2;
printwrap("\\draw");
$Printwrap += 2;
my $join = '';
foreach my $p (@points) {
  my ($x,$y) = @$p;
  printwrap("$join($x,$y)");
  $join = '--';
}
printwrap(";\n");

print "  % end generated\n";
exit 0;
